﻿using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;
using System.Threading;


namespace TPM
{
	public class GFXEditing
	{
		private Form orginalform;
		
		private int _frameColor=0;
		private int _indexer = 10;
		public int Multipler;

		private  Color FrameColor
		{
			get
			{
				_frameColor += _indexer;
				if (_frameColor >= 250){_indexer = _indexer == 10 ? -10 : 10;}
				if (_frameColor <=0 ){_indexer = _indexer == -10 ? 10 : -10;}
				_frameColor += _indexer;
				return Color.FromArgb(_frameColor,_frameColor,_frameColor);
			}
			
		}

		public GFXEditing( Form sendedform )
		{
			orginalform = sendedform;
		}

		#region Metody dokonujace obliczen

		public Point ObliczRamke( Size _resolutionPicbox, Point _kursor )
		{
			var tmp = new Point(_kursor.X / (_resolutionPicbox.Width / Multipler), _kursor.Y / (_resolutionPicbox.Height / Multipler));
			return tmp;
		}




		/// <summary>
		/// Calculate the rectangle from image resolution.
		/// </summary>
		/// <param name="_resolutionPicbox">The _resolution picbox.</param>
		/// <param name="_resolutionImage">The _resolution image.</param>
		/// <param name="_kursor">The _kursor.</param>
		/// <returns></returns>
		public Rectangle ObliczRectangle( Size _resolutionPicbox, Size _resolutionImage, Point _kursor )
		{
			
			var ramka = ObliczRamke(_resolutionPicbox, _kursor);
			var rectStart = new Point((_resolutionImage.Width / Multipler) * ramka.X, (_resolutionImage.Height / Multipler) * ramka.Y);
			var _rectEnd = new Point((_resolutionImage.Width / Multipler), (_resolutionImage.Height / Multipler));
			var rectangle = new Rectangle(rectStart.X, rectStart.Y, _rectEnd.X, _rectEnd.Y);
			return rectangle;
		}

		#endregion Metody dokonujace obliczen

		#region Metody odpowiedzialne za obsluge grafiki


		/// <summary>
		/// Copies the rectangle.
		/// </summary>
		/// <param name="_srcimg">The _srcimg.</param>
		/// <param name="_dstimg">The _dstimg.</param>
		/// <param name="rec1">The rec1.</param>
		/// <param name="rec2">The rec2.</param>
		/// <returns>Return a cuted rectangle</returns>
		public Bitmap CopyRectangle( Bitmap _srcimg, Bitmap _dstimg, Rectangle rec1, Rectangle rec2 )
		{
			var _rectangle1 = rec1;
			var _rectangle2 = rec2;
			
			using (Graphics _tmpimage = Graphics.FromImage(_dstimg))
			{
				_tmpimage.SetClip(_rectangle1);
				_tmpimage.Clear(Color.Transparent);
				_tmpimage.ResetClip();
				_tmpimage.DrawImage(new Bitmap(_srcimg), _rectangle1, _rectangle2, GraphicsUnit.Pixel);
			}
			return _dstimg;
		}



		#endregion Metody odpowiedzialne za obsluge grafiki

		public Bitmap FlashFrame(Rectangle _rectangle, Bitmap _image)
		{
			var temp = new Bitmap(_image);
			using (var g = Graphics.FromImage(temp))
			{
				var pen = new Pen(FrameColor, 2);
				g.DrawRectangle(pen, _rectangle);
			}

			return temp;
			//	ControlPaint.DrawReversibleFrame(_rectangle,Color.Black,FrameStyle.Dashed);

		}

		
		
	}
}