﻿using System.Drawing;
using System.Windows.Forms;
using System.Threading;


namespace Texturizer
{
	public class GFXEditing
	{
		private Form orginalform;

		public GFXEditing( Form sendedform )
		{
			orginalform = sendedform;
		}

		#region Metody dokonujace obliczen

		public Point ObliczRamke( Size _resolutionPicbox, Point _kursor )
		{
			Point _tmp = new Point(_kursor.X / (_resolutionPicbox.Width / 16), _kursor.Y / (_resolutionPicbox.Height / 16));
			return _tmp;
		}

		/// <summary>
		/// Oblicza Rectangle na podstawie rozdzielczosci obrazka
		/// </summary>
		/// <param name="_ramka">wybrana ramka obrazka od 0 do 15</param>
		/// <param name="_resolutionPicbox">rozdzielczosc PictureBoxa</param>
		/// <param name="_resolutionImage">rozdzielczosc obrazka</param>
		/// <param name="_kursor">pozycja kursora w picboxie</param>
		/// <returns></returns>
		public Rectangle ObliczRectangle( Size _resolutionPicbox, Size _resolutionImage, Point _kursor )
		{
			var ramka = ObliczRamke(_resolutionPicbox, _kursor);
			var rectStart = new Point((_resolutionImage.Width / 16) * ramka.X, (_resolutionImage.Height / 16) * ramka.Y);
			var _rectEnd = new Point((_resolutionImage.Width / 16), (_resolutionImage.Height / 16));
			var rectangle = new Rectangle(rectStart.X, rectStart.Y, _rectEnd.X, _rectEnd.Y);
			return rectangle;
		}

		#endregion Metody dokonujace obliczen

		#region Metody odpowiedzialne za obsluge grafiki

		/// <summary>
		/// Metoda czysci ramke dst i kopjuje ramke z src do dst
		/// </summary>
		/// <param name="_srcimg">source image</param>
		/// <param name="_dstimg">destination image</param>
		/// <param name="_rectangle1">kwadrat z source</param>
		/// <param name="_rectangle2">kwadrat z destination</param>
		/// <returns></returns>
		public Bitmap CopyRectangle( Bitmap _srcimg, Bitmap _dstimg, Rectangle _rectangle1, Rectangle _rectangle2 )
		{
			using (Graphics _tmpimage = Graphics.FromImage(_dstimg))
			{
				_tmpimage.SetClip(_rectangle1);
				_tmpimage.Clear(Color.Transparent);
				_tmpimage.ResetClip();
				_tmpimage.DrawImage(_srcimg, _rectangle1, _rectangle2, GraphicsUnit.Pixel);
			}
			return _dstimg;
		}



		#endregion Metody odpowiedzialne za obsluge grafiki

		public Image FlashFrame(Image _image,Rectangle _rectangle)
		{
			if (_image != null && _rectangle != null)
			{
				
				//using (Graphics _tmpimage = Graphics.FromImage(_image))
				//{
					Monitor.TryEnter(this);
					//var kolor = new Pen(TextureBrush);
					
				
					ControlPaint.DrawReversibleFrame(_rectangle,Color.Black,FrameStyle.Dashed);
					Monitor.Exit(this);
				//}
			}

			return _image;
		}
	}
}