﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Ionic.Zip;
using System.Threading;



namespace Texturizer
{
	public partial class Texturizer : Form
	{
		//deklaracje zmiennych globalnych dla klasy
		//zmienne do instancji grafik
		public Bitmap src_image { get; set; }
		public Bitmap dst_image { get; set; }
		public Bitmap src_art_png { get; set; }
		public Bitmap dst_art_png { get; set; }
		public Bitmap FrameIMG { get; set; }			//orginalny obrazek frame
		public Bitmap FrameIMGbuffer { get; set; }		//Rectangle grafiki wyciety przed namalowaniem ramki

		public List<string> PathesListSRC = new List<string>(); /// Lista zapisujaca istniejace patche do plikow SRC
		public List<string> PathesListDST = new List<string>();	/// Lista zapisujaca istniejace patche do plikow DST
	   
		//zmienna dla tworzenia instancji objektu IOClass
		public GFXEditing Oblicz;
		public IOClass IO;

		private Rectangle rectangle1 { get; set; }
		private Rectangle rectangle2 { get; set; } /// rectangle wyliczane dla source i dest image
		//private string[,] items { get; set; } ///deklaracja nazw itemow z terrain.png

		private Object o = new Object();
		private System.Drawing.Size _picbox;
		private System.Drawing.Size _image;

		public Texturizer()
		{
			InitializeComponent();
			IO = new IOClass(this);
			Oblicz = new GFXEditing(this);
			IO.PrepareDirs("all");
			fileslistBox.Items.Clear();
			FrameIMG = global::Texturizer.Properties.Resources.na_ikone;
			DrawFrameBW.RunWorkerAsync();
		}
		//
		// przypisanie danych do zmiennych
		//
		private void Texturizer_Load(object sender, EventArgs e)
		{
			//    items =new string[16,16] {
			//    {"Gravel","Rock","Dirt","Grass Block","Wooden Planks","Stone Slabs","Stone Slabs","Stone Bricks","TNT","TNT","TNT","CodeWeb","Rose","Flower","?","Sapling"},
			//    {"Cobblestone","Bedrock","Sand","Gravel","Wood","Wood","Iron Block","Gold Block","Diamond Block","Single Chest","Single Chest","Single Chest","Mushrom","Mushrom","Sapling","?"},
			//    {"Gold Ore","Iron Ore","Coal Ore","Bookshelf","Moss Stone","Obsidian","Grass Block","mask Dirt","?","Double Chest","Double Chest","Workbench","Furnance","Furnance/Dispenser","Dispenser","?"},
			//    {"Sponge","Glass","Diamond Ore","Redstone Ore","Leaves","Leaves","Stone Bricks","Dead Bush","Fern","Double Chest","Double Chest","Workbench","Workbench","Fired Furnance","Furnance/Dispenser","Sapling"},
			//    {"Wool","Monster Spawner","Snow Block","Ice","Snow","Cactus","Cactus","Cactus","Clay","Sugar Cane","Note Block","Juke Box","Lily Pad","Mycelium","Mycelium","Sapling"},
			//    {"Torch","Wooden Door","Iron Door","Ladder","Trapdor","Iron Bars","Water Farm Land","Farm Land","Wheat","Wheat","Wheat","Wheat","Wheat","Wheat","Wheat","Wheat" },
			//    {"Lever","Wooden Door","Iron Door","Redstone Torch ON","Stone Bricks","Stone Bricks","Pumpkin","Netherrack","SoulSand","Glowstone","Sticky Piston","Piston","Piston Sides","Piston Sides","Piston Sides","Melon/Pumpkin Stem" },
			//    {"Rail","Wool","Wool","Redstone Torch OFF","Wood","Wood","Pumpkin","Pumpkin","Jack'o'Latern","Cake","Cake","Cake","Cake","Huge Mushroom","Huge Mushroom","Melon/Pumpkin Stem"},
			//    {"Rail","Wool","Wool","Repeater OFF","Leaves","Leaves","Bed","Bed","Melon","Melon","Cauldurion","Cauldurion","Cake","Big Mushroom","Big Mushroom","Wines"},
			//    {"Lapis Lazuri Block","Wool","Wool","Repeater ON","Redstone Wire","Bed","Bed","Bed","Bed","Wood","Cauldurion","Cauldurion","Brewing","Brewing","Portal Stone","Portal Stone"},
			//    {"Lapis Lazuri Ore","Wood","Wood","Unpowered Rail","Redstone Wire","Redstone Wire","Enchancment Table","Enchancment Table","?","?","?","?","?","?","Eye","Portal Stone"},
			//    {"Sandstone","Wool","Wool","Powered Rail","?","?","Enchantment Table","Enchantment Table","?","?","?","?","?","?","?","Portal Stone" },
			//    {"Sandstone","Wool","Wool","Rail Detector","Jungle Leaves","Jungle Leaves","Wood Planks","Wood Planks","?","?","?","?","?","Water","Water","Water"},
			//    {"Sandstone","Wool","Wool","Redstone Lamp OFF","Redstone Lamp ON","Stone Bricks Specjal","Wood Planks","?","?","?","?","?","?","?","Water","Water"},
			//    {"Nether Bricks","Wool","Nether Wart","Nether Wart","Nether Wart","Sandstone SIde","Sandstone Side","?","?","?","?","?","?","Lava","Lava","Lava"},
			//    {"Destroy Block","Destroy Block","Destroy Block","Destroy Block","Destroy Block","Destroy Block","Destroy Block","Destroy Block","Destroy Block","Destroy Block","?","?","?","?","Lava","Lava"},
			//};
				
				RefreshForm();
		}



		
		
		/// <summary>
		/// Metoda odswierza Forma texturizera
		/// </summary>
		private void RefreshForm()
		{
			#region refresh labels i pictureboxy
						if (dst_image == null) 
					{
						DstPicBox.Image = global::Texturizer.Properties.Resources.PicBox_Background;
						DstLabel.Text = ( "Destination resolution: NO IMAGE" );
					}
					else 
					{ 
						DstPicBox.Image = dst_image;
						DstLabel.Text = ( "Destination resolution: " + dst_image.Width / 16 + " x " + dst_image.Height / 16 ); 
					}

					if (src_image == null) 
					{
						SrcPicBox.Image = global::Texturizer.Properties.Resources.PicBox_Background;
						SrcLabel.Text = ( "Source resolution: NO IMAGE" );
					}
					else 
					{
						SrcPicBox.Image = src_image;
						SrcLabel.Text = ( "Source resolution: " + src_image.Width / 16 + " x " + src_image.Height / 16 );
					}
			#endregion

			#region refresh listboxa, wypelnia go danymi
					foreach (var item in PathesListDST)
	{
						fileslistBox.Items.Add(item.Substring(item.LastIndexOf(@"\")+1));
	}
						
					
			#endregion
		}


		/// <summary>
		/// zdarzenie wylicza rectangle dla obrazkow w zaleznosci od ich rozdzielczosci i kopiuje grafike
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void SrcPicBox_MouseClick(object sender, MouseEventArgs e)
		{
			if ( src_image != null && dst_image != null )
			{
				_picbox = new Size(SrcPicBox.Width, SrcPicBox.Height);
				_image = new Size(src_image.Width, src_image.Height);
				Point _kursor = new Point(e.X, e.Y);
				Point _tymczasowo;
				_tymczasowo = Oblicz.ObliczRamke(_picbox, _kursor);
				rectangle1 = Oblicz.ObliczRectangle(_picbox, _image, _kursor);
				_picbox = new Size(DstPicBox.Width, DstPicBox.Height);
				_image = new Size(dst_image.Width, dst_image.Height);
				rectangle2 = Oblicz.ObliczRectangle(_picbox, _image, _kursor);
				dst_image = Oblicz.CopyRectangle(src_image, dst_image, rectangle2, rectangle1);
				DstPicBox.Refresh();	
			}				
		}


		/// <summary>
		/// zdarzenie zamkniecia programu, sprawdza czy zostal zapisany postep pracy
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Texturizer_FormClosing(object sender, FormClosingEventArgs e)
		{
			//MessageBox.Show("Tu będzie komunikat czy zapisać zmiany");
		}

		/// <summary>
		/// zdarzenie otwarcie nowego okna About
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Form About = new AboutBox1();
			About.Show();
		}

		/// <summary>
		/// Wyjscie z programu z poziomu strip menu list
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void exitToolStripMenuItem_Click(object sender, EventArgs e)
		{
			this.Close();
		}

		/// <summary>
		/// Load pliku .zip. W zaleznosci od aktywnego taba ustawia katalog dla depakera na SRC lub DST
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void loadSrcAszipToolStripMenuItem_Click(object sender, EventArgs e)
		{
			
			if ( src_image != null )
			{
				src_image.Dispose();
				src_image = global::Texturizer.Properties.Resources.PicBox_Background;
			}
			 IO.Load_zip("src");
			//src_png = (Bitmap)Bitmap.FromFile( _temp, true );
			IO.CzySaTakiePliki(ref PathesListSRC, ref PathesListDST, "src");
			IO.PorownajListy(ref PathesListSRC, ref PathesListDST);
			RefreshForm();
			
		}

		/// <summary>
		/// Load pliku .zip. W zaleznosci od aktywnego taba ustawia katalog dla depakera na SRC lub DST
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void loadDstAszipToolStripMenuItem_Click(object sender, EventArgs e)
		{
			
			if ( dst_image != null )
			{
				dst_image.Dispose();
				dst_image = global::Texturizer.Properties.Resources.PicBox_Background;
			}
			IO.Load_zip("dst");
			IO.CzySaTakiePliki( ref PathesListSRC, ref PathesListDST, "dst" );
			IO.PorownajListy(ref PathesListSRC, ref PathesListDST);
			RefreshForm();
			
			
		}

		/// <summary>
		/// Spakowanie i zapis archiwum .zip
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void saveDestAspngToolStripMenuItem_Click(object sender, EventArgs e)
		{
			
			if (dst_image != null)
			{
				IO.SaveFile("terrain.png", dst_image);
			}
			else
			{
				MessageBox.Show( "Nothing to save", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error );
			}
			
		}

		

		private void fileslistBox_MouseDoubleClick( object sender, MouseEventArgs e )
		{
			if (PathesListSRC.Count==0 && PathesListDST.Count==0)
			{
				return;
			}
			
			string srcPath = null;
			string dstPath = null;

			srcPath = PathesListSRC.ElementAt(fileslistBox.SelectedIndex);
			dstPath = PathesListDST.ElementAt(fileslistBox.SelectedIndex);

			src_image = IO.LoadFile( srcPath );
			dst_image = IO.LoadFile( dstPath );
			RefreshForm();

		}

		private void SrcPicBox_MouseMove( object sender, MouseEventArgs e )
		{
			//System.Diagnostics.Debug.WriteLine(e.Location.ToString());
		}



		private void DrawFrameBW_DoWork( object sender, DoWorkEventArgs e )
		{

			var pen = new Pen(Color.White);
			int red = 0;
			int indexer = 10;
			Rectangle rec = new Rectangle();
						
				while (DrawFrameBW.CancellationPending)
				{
											
					if (red==250)
					{
						red = 250;
						indexer = -10;
					}
					if (red==0)
					{
						red = 0;
						indexer = 10;
					}
						
					red += indexer;
					//pen.Color = Color.FromArgb(alpha, red, red, red);

					//var ImageOut = new Bitmap(src_image);
					//var g = Graphics.FromImage(SrcPicBox.Image);
					//g.DrawRectangle(pen, rectangle1);	
						
					label1.Text = red.ToString();
						
						//System.Diagnostics.Debug.WriteLine(pen.Color.ToString());
						Thread.Sleep(10);
	
					}
					e.Cancel = true;
					label1.Text = "BW exited";


				}
			}

			

}

